package com.zhongshu.card.server.core.dao.visitor.impl;

import com.github.microservice.components.data.mongo.mongo.helper.DBHelper;
import com.zhongshu.card.server.core.dao.BaseImpl;
import com.zhongshu.card.server.core.dao.visitor.extend.VisitorSettingDeviceDaoExtend;
import com.zhongshu.card.server.core.domain.visitor.VisitorSettingDevice;
import com.zhongshu.card.client.model.visitor.setting.VisitorSettingDeviceSearch;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Pattern;

/**
 * @Author TRX
 * @CreateDate: 2023/4/12
 * @Version: 1.0
 */
public class VisitorSettingDeviceDaoImpl extends BaseImpl implements VisitorSettingDeviceDaoExtend {

    @Autowired
    private DBHelper dbHelper;

    @Override
    public Page<VisitorSettingDevice> page(Pageable pageable, VisitorSettingDeviceSearch param) {
        Criteria criteria = buildFilterCriteria(param);

        Sort sort = buildSort(param);
        Query query = Query.query(criteria);
        query.with(sort);
        return dbHelper.pages(query, pageable, VisitorSettingDevice.class);
    }

    private Criteria buildFilterCriteria(VisitorSettingDeviceSearch param) {
        Criteria criteria = buildCriteriaNotOid(param);

        if (StringUtils.isNotEmpty(param.getProjectOid())) {
            criteria.and("projectOid").is(param.getProjectOid());
        }

        if (StringUtils.isNotEmpty(param.getSceneComponentId())) {
            criteria.and("sceneComponentId").is(param.getSceneComponentId());
        }
        if (param.getDeviceType() != null) {
            criteria.and("deviceType").is(param.getDeviceType());
        }

        // 模糊搜索
        List<Criteria> criterias = new ArrayList<>();
        if (StringUtils.isNotEmpty(param.getDeviceId())) {
            Pattern pattern = Pattern.compile("^.*" + param.getDeviceId() + ".*$");
            criterias.add(Criteria.where("deviceId").is(pattern));
        }
        if (StringUtils.isNotEmpty(param.getDeviceName())) {
            Pattern pattern = Pattern.compile("^.*" + param.getDeviceName() + ".*$");
            criterias.add(Criteria.where("deviceName").is(pattern));
        }
        if (!CollectionUtils.isEmpty(criterias)) {
            criteria.andOperator(criterias.toArray(new Criteria[]{}));
        }
        return criteria;
    }

}
